# AskYourPDF API Documentation

## Introducing the AskYourPDF API

AskYourPDF is a cutting-edge solution revolutionizing document interactions. Our API empowers developers with the ability to programmatically extract valuable information from PDF files and leverage it to create custom chatbots. By providing seamless access to the content within PDF documents, developers can build powerful applications that enable users to navigate, search, and engage with data effortlessly. This comprehensive guide will walk you through the API's features, pricing, authentication methods, and usage guidelines, opening up endless possibilities to enhance productivity and knowledge retrieval for your applications. Harness the potential of AskYourPDF API and embark on an innovative journey of intelligent document analysis and interactive experiences.

## **Uploading A Document** &#x20;

To upload a document, choose between [generating a document](https://askyourpdf.com/upload) ID on our website or using the API endpoint. We support various document formats, including '.pdf', '.txt', '.ppt', '.pptx', '.csv', '.epub', and '.rtf'. Additionally, you can upload PDFs using links. Moreover, the API enables interaction with any blog post or website by providing the link to the post.

## **Authentication**&#x20;

Authentication is required for all our API endpoints. To access them, you must [generate API keys](https://askyourpdf.com/developers/apiKeys) on your AskYourPDF account. These API keys need to be set in your request header as "x-api-key." It is essential to treat your API key as a secret and ensure its protection.

```json
headers: {
    "x-api-key": "ask_xxxxx"
  }

```

##

## **1.  Adding Document via URL**

{% openapi src="<https://api.askyourpdf.com/openapi.json>" path="/v1/api/download\_pdf" method="get" %}
<https://api.askyourpdf.com/openapi.json>
{% endopenapi %}

### **Query Parameters:**

* `url` (required): The link to the document. It could be a link to a PDF or a post on a website

### **Response:**

* `201` Successful Response
  * `doc_id` (`string`): The document ID of the uploaded document.

```json
{ "doc_id": "6e60e87c-6154-4dff-8e62-ff10d8ed16dd" }
```

### **Examples:**

{% code title="cURL" %}

```markup
curl -X GET 
'https://api.askyourpdf.com/v1/api/download_pdf?url=https://www.example.com/document.pdf' 
-H 'x-api-key: YOUR_API_KEY'

```

{% endcode %}

{% code title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

response = requests.get('https://api.askyourpdf.com/v1/api/download_pdf', 
headers=headers, 
params={'url': 'https://www.example.com/document.pdf'})

if response.status_code == 201:
    print(response.json())
else:
    print('Error:', response.status_code)
```

{% endcode %}

{% code title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
    'x-api-key': 'YOUR_API_KEY'
};

axios.get('https://api.askyourpdf.com/v1/api/download_pdf', {
  headers: headers,
  params: {
    url: 'https://www.example.com/document.pdf'
  }
})
.then((response) => {
  if (response.status === 201) {
    console.log(response.data);
  } else {
    console.log('Error:', response.status);
  }
})
.catch((error) => {
  console.error(error);
});
```

{% endcode %}

##

## **2. Adding Document via File Upload**

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/v1/api/upload" method="post" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

### **Request body:**

**The request body should be sent as a form of data with the name `file` (see example).**

* `file` (required): The raw bytes of the file to be uploaded.

### **Response:**

* `201` Successful Response
  * `doc_id` (`string`): The document ID of the uploaded document.

```json
{ "doc_id": "6e60e87c-6154-4dff-8e62-ff10d8ed16dd" }
```

### **Examples:**

{% code title="cURL" %}

```markup
curl -X POST 
-H 'x-api-key: YOUR_API_KEY' 
-F "file=@/path/to/yourfile.pdf" https://api.askyourpdf.com/v1/api/upload


```

{% endcode %}

{% code title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

file_data = open('/path/to/yourfile.pdf', 'rb')

response = requests.post('https://api.askyourpdf.com/v1/api/upload', headers=headers,
 files={'file': file_data})

if response.status_code == 201:
    print(response.json())
else:
    print('Error:', response.status_code)

```

{% endcode %}

{% code title="Javascript" %}

```javascript
const axios = require('axios');
const FormData = require('form-data');
const fs = require('fs');

const headers = {
    'x-api-key': 'YOUR_API_KEY'
};

let form = new FormData();
form.append('file', fs.createReadStream('/path/to/yourfile.pdf'));

axios.post('https://api.askyourpdf.com/v1/api/upload', form, {
  headers: {
    ...headers,
    ...form.getHeaders()
  }
})
.then((response) => {
  if (response.status === 201) {
    console.log(response.data);
  } else {
    console.log('Error:', response.status);
  }
})
.catch((error) => {
  console.error(error);
});

```

{% endcode %}

##

## **3. Chat Endpoint**

Endpoint for initiating a chat with a document. This endpoint requires API Key Header authentication.

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/v1/chat/{doc\_id}" method="post" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

### **Path Parameters:**

`doc_id` (`string`, required): The ID of the document for the conversation.

### **Query Parameters:**

* `stream` (`boolean`, optional): Flag for streaming. Default is `false`<br>
* model\_name (string, optional) : The model the user chooses to use, model choices includes CLAUDE1, CLAUDE2, GPT3, GPT4, GPT4O\_MINI. Default model is GPT4O\_MINI
* agent\_mode (boolean, optional) : Enabled by default. This flag determines whether the system uses our agent to answer your question. When set to `True`, responses may take slightly longer but are generally more accurate and higher quality than those generated in normal mode.
* cite\_source (boolean, optional) :  Flag for cite\_sources. Default if false
* temeperature (float, optional) : Flag for temperature. Default is 0.7&#x20;
* language (string, optional) : The language the user chooses to chat with, language choices include  ENGLISH, ARABIC, CHINESE, JAPANESE, FRENCH , GERMAN, SPANISH, KOREAN, PORTUGESE.  Default language is ENGLISH.
* length (string, optional) **:** This option allows you to choose the desired length of the response. Choices includes LONG and SHORT. Default value is SHORT

### **Request body:**

* `sender` (`required`): The sender of the chat message. The sender should be `User`
* `message` (`required`): The chat message content.

**The request body to ask a single question.**

<pre class="language-json"><code class="lang-json">[
<strong>  {
</strong>    "sender": "User",
    "message": "What does this document say?"
  }
]
</code></pre>

**To ask a follow-up question and provide the model with context you can send your previous questions and responses in the following format.**

```json
[
    {   
    "sender": "user",
    "message": "What does the document say?"
    },
    {
    "sender": "bot",
    "message": "The document consists of words in different languages expressing gratitude"
     },
   {
    "sender": "user",
    "message": "What is the word expressing gratitude in Spanish?"
    }
]
```

### **Response:**

**The response when the query parameter** `stream = False`

* `200` Successful Response
  * `question`: The question posed by the user, with sender, message, and type.
    * `sender`
    * `message`
    * `type`
  * `answer`: The answer provided by the AI, with sender, message, and type.
    * `sender`
    * `message`
    * `type`
  * `created` (`string`): The time the chat was created.

```json
{
  "question": {
    "sender": "user",
    "message": "What does this document say?",
    "type": "question"
  },
  "answer": {
    "sender": "bot",
    "message": "This document talks about AI",
    "type": "response"
  },
  "created": "2023-07-20T11:14:55.928Z"
}
```

**By setting the query parameter**  `stream = True,` **you can receive the response as a stream of token.  An example of the response can be seen below.**

```javascript
Chunk: This
Chunk: document
Chunk: talks
Chunk: about
Chunk: AI

```

### **Example when stream = False:**

{% code title="cURL" %}

```markup
curl -X POST 
-H 'Content-Type: application/json' 
-H 'x-api-key: YOUR_API_KEY' 
-d '[{"sender": "User","message": "What does this document say?"}]'
 https://api.askyourpdf.com/v1/chat/{YOUR_DOC_ID}


```

{% endcode %}

{% code title="Python" %}

```python
import requests
import json

headers = {
    'Content-Type': 'application/json',
    'x-api-key': 'YOUR_API_KEY'
}

data = [
    {
        "sender": "User",
        "message": "What does this document say?"
    }
]

response = requests.post('https://api.askyourpdf.com/v1/chat/{YOUR_DOC_ID}', 
headers=headers, data=json.dumps(data))

if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)

```

{% endcode %}

{% code title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
    'Content-Type': 'application/json',
    'x-api-key': 'YOUR_API_KEY'
};

const data = [
    {
        "sender": "User",
        "message": "What does this document say?"
    }
];

axios.post('https://api.askyourpdf.com/v1/chat/{YOUR_DOC_ID}', data, {headers: headers})
.then((response) => {
    if (response.status === 200) {
        console.log(response.data);
    } else {
        console.log('Error:', response.status);
    }
})
.catch((error) => {
    console.error(error);
});
```

{% endcode %}

### **Example when stream = True:**

{% code title="Python" %}

```python
import requests
import json

headers = {
    'Content-Type': 'application/json',
    'x-api-key': 'YOUR_API_KEY'
}

data = [
    {
        "sender": "User",
        "message": "What does this document say?"
    }
]

try:
    response = requests.post(
        'https://api.askyourpdf.com/v1/chat/YOUR_DOC_ID?stream=True',
        headers=headers, data=json.dumps(data))
    response.raise_for_status()

    for chunk in response.iter_content(chunk_size=24):
        chunk_str = chunk.decode('utf-8')
        print("Chunk:", chunk_str)

except requests.exceptions.RequestException as error:
    print("Error:", error)

```

{% endcode %}

{% code title="Javascript" %}

```javascript
const fetch = require('node-fetch');
const Readable = require('stream').Readable;


const headers = {
    'Content-Type': 'application/json',
    'x-api-key': 'YOUR_API_KEY'
}

const data = [
    {
        "sender": "User",
        "message": "What does this document say?"
    }
]

fetch('https://api.askyourpdf.com/v1/chat/YOUR_DOC_ID?stream=True', {
    method: 'POST',
    headers: headers,
    body: JSON.stringify(data)
})
    .then(response => {
        if (!response.ok) {
            throw new Error(`HTTP error! status: ${response.status}`);
        }
        return response.body;
    })
    .then(stream => {
        const reader = Readable.from(stream);
        reader.on('data', chunk => {
            console.log("Chunk:", chunk.toString('utf-8'));
        });
    })
    .catch(error => {
        console.log("Error:", error);
    });
```

{% endcode %}

## 4.  Chat with multiple documents

This endpoint allows a user to chat with more than one docuemt.

```
POST /v1/api/knowledge_base_chat
```

<details>

<summary>Authorization</summary>

API Key

</details>

## Query paramters

* `stream` (`boolean`, optional): Flag for streaming. Default is `false`
* model\_name (string, optional) : The model the user chooses to use, model choices includes CLAUDE1, CLAUDE2, GPT3, GPT4, GPT4O\_MINI. Default model is GPT4O\_MINI
* agent\_mode (boolean, optional) : Enabled by default. This flag determines whether the system uses our agent to answer your question. When set to `True`, responses may take slightly longer but are generally more accurate and higher quality than those generated in normal mode.
* cite\_source (boolean, optional) :  Flag for cite\_sources. Default if false
* temperature (float, optional) : Flag for temperature. Default is 0.7&#x20;
* language (string, optional) : The language the user chooses to chat with, language choices include  ENGLISH, ARABIC, CHINESE, JAPANESE, FRENCH , GERMAN, SPANISH, KOREAN, PORTUGESE.  Default language is ENGLISH.
* length (string, optional) **:** This option allows you to choose the desired length of the response. Choices includes LONG and SHORT. Default value is SHORT

## Body

```json
{
  "documents": [
    "3c06c3f8-be9f-4f43-ac00-b1a82fd25b30"
  ],
  "messages": [
    {
      "sender": "user",
      "message": "What is the document all about"
    }
  ]
}
```

## Response:

* 200 : Successful Response
  * question : A dict of information directed to the model

    * sender : The sender of the question,
    * message : The question asked&#x20;
    * type : Has a value of "question"

  * answer : A dict of response information from  the model
    * sender : The sender of the response
    * message : The exact answer a user requested &#x20;
    * type : Has a value of "response"

```json
{
  "question": {
    "sender": "user",
    "message": "What is the document all about",
    "type": "question"
  },
  "answer": {
    "sender": "bot",
    "message": "The document simply describes the applications of motions",
    "type": "response"
  },
  "created": "2024-08-23T11:01:46.204541"
}
```

## Examples

```markup
curl -X POST 'https://api.askyourpdf.com/v1/api/knowledge_base_chat?model_name=GPT3&stream=false&length=LONG&language=ARABIC&temperature=0.7' \
  -H 'x-api-key: YOUR_API_KEY' \
  -H 'Content-Type: application/json' \
  -d '{
    "documents": [
      "3c06c3f8-be9f-4f43-ac00-b1a82fd25b30"
    ],
    "messages": [
      {
        "sender": "user",
        "message": "What is the document all about"
      }
    ]
  }'
```

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

payload = {
  "documents": [
    "3c06c3f8-be9f-4f43-ac00-b1a82fd25b30"
  ],
  "messages": [
    {
      "sender": "user",code
      "message": "What is the document all about"
    }
  ]
}

params = {
"model_name":"GPT3",
"stream":False,
"length":"LONG",
"language":"ARABIC",
"temperaature":0.7
}

response = requests.post('https://api.askyourpdf.com/v1/api/knowledge_base_chat', 
headers=headers, json=payload, params = params)

if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)
```

```javascript
const axios = require('axios');

const headers = {
  'x-api-key': 'YOUR_API_KEY'
};

const payload = {
  "documents": [
    "3c06c3f8-be9f-4f43-ac00-b1a82fd25b30"
  ],
  "messages": [
    {
      "sender": "user",
      "message": "What is the document all about"
    }
  ]
};

const params = {
  "model_name": "GPT3",
  "stream": false,
  "length": "LONG",
  "language": "ARABIC",
  "temperature": 0.7
};

axios.post('https://api.askyourpdf.com/v1/api/knowledge_base_chat', payload, {
  headers: headers,
  params: params
})
  .then(response => {
    console.log(response.data);
  })
  .catch(error => {
    console.error('Error:', error.response ? error.response.status : error.message);
  });
```

## 5.  Documents Retrieval Endpoint

This endpoint allows users to retrieve a paginated list of their uploaded documents.

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/v1/api/documents" method="get" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

### **Query Parameters:**

* `page` (`integer`, optional): The page to return. Defaults to `1`.
* page\_size (integer, optional): The number of documents to return per page. Defaults to 10.

### **Response:**

* `200` Successful Response
  * `total_pages` (Integer): The total number of pages available for querying
  * `documents` (Array): A list of document details belonging to the user.
    * `name`
    * `doc_id`
    * `summary`
    * `language`
    * `pages`
    * `shareable`
    * `date_time`

```json
{
  "total_pages": 1,
  "documents": [
    {
      "name": "Nature.pdf",
      "doc_id": "6e60e87c-6154-4dff-8e62-ff10d8ed16dd",
      "summary": "This is a document about nature",
      "language": "en",
      "pages": 10,
      "shareable": true,
      "date_time": "2023-07-21T06:18:18.891Z"
    }
  ]
}
```

### **Examples:**

{% code title="cURL" %}

```markup
curl -X GET 
-H 'x-api-key: YOUR_API_KEY' 
'https://api.askyourpdf.com/v1/api/documents?page=1&page_size=10'
```

{% endcode %}

{% code title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

params = {
    'page': 1,
    'page_size': 10
}

response = requests.get('https://api.askyourpdf.com/v1/api/documents', 
headers=headers, params=params)

if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)

```

{% endcode %}

{% code title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
    'x-api-key': 'YOUR_API_KEY'
};

const params = {
    'page': 1,
    'page_size': 10
};

axios.get('https://api.askyourpdf.com/v1/api/documents', 
{headers: headers, params: params})
.then((response) => {
  if (response.status === 200) {
    console.log(response.data);
  } else {
    console.log('Error:', response.status);
  }
})
.catch((error) => {
  console.error(error);
});

```

{% endcode %}

##

## 6.  Single Document Retrieval Endpoint

This endpoint allows users to retrieve a single document.

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/v1/api/documents/{doc\_id}" method="get" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

### **Path Parameters:**

`doc_id` (`string`, required): The ID of the document for the conversation.

### **Response:**

* `200` Successful Response
  * `name`
  * `doc_id`
  * `summary`
  * `language`
  * `pages`
  * `shareable`
  * `date_time`

```json
  {
    "name": "Nature.pdf",
    "doc_id": "6e60e87c-6154-4dff-8e62-ff10d8ed16dd",
    "summary": "This is a document about nature",
    "language": "en",
    "pages": 10,
    "shareable": true,
    "date_time": "2023-07-21T06:18:18.891Z"
  }
```

### **Examples:**

{% code title="cURL" %}

```markup
curl -X GET
 -H 'x-api-key: YOUR_API_KEY' 
 'https://api.askyourpdf.com/v1/api/documents/{YOUR_DOC_ID}'

```

{% endcode %}

{% code title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

response = requests.get('https://api.askyourpdf.com/v1/api/documents/{YOUR_DOC_ID}',
 headers=headers)

if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)

```

{% endcode %}

{% code title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
    'x-api-key': 'YOUR_API_KEY'
};

axios.get('https://api.askyourpdf.com/v1/api/documents/{YOUR_DOC_ID}',
 {headers: headers})
.then((response) => {
    if (response.status === 200) {
        console.log(response.data);
    } else {
        console.log('Error:', response.status);
    }
})
.catch((error) => {
    console.error(error);
});

```

{% endcode %}

##

## 7.  Delete Document Endpoint

Allows users to delete a single document

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/v1/api/documents/{doc\_id}" method="delete" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

### **Path Parameters:**

`doc_id` (`string`, required): The ID of the document to be deleted.

### **Response:**

* `200` Successful Response

<pre class="language-json"><code class="lang-json"><strong> {"message": "Document deleted successfully"}
</strong></code></pre>

### **Examples:**

{% code title="cURL" %}

```markup
curl -X DELETE 
-H 'x-api-key: YOUR_API_KEY' 
'https://api.askyourpdf.com/v1/api/documents/DOC_ID'

```

{% endcode %}

{% code title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

response = requests.delete('https://api.askyourpdf.com/v1/api/documents/DOC_ID', headers=headers)

if response.status_code == 200:
    print('Document deleted successfully')
else:
    print('Error:', response.status_code)


```

{% endcode %}

{% code title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
    'x-api-key': 'YOUR_API_KEY'
};

axios.delete('https://api.askyourpdf.com/v1/api/documents/DOC_ID', {headers: headers})
.then((response) => {
    if (response.status === 200) {
        console.log('Document deleted successfully');
    } else {
        console.log('Error:', response.status);
    }
})
.catch((error) => {
    console.error(error);
});

```

{% endcode %}

## KnowledgeBase Endpoints

Knowledgebase endpoints are used when a user wants to chat or interact with multiple documents

### 8. Get Knowledge Bases

This endpoint enables an authenticated user to retrieve paginated knowledgebases\
\
Returns: \
PaginatedKnowledgeBase: The response containing the updated knowledge base.

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/api/knowledge" method="get" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

```
GET /api/knowledge
```

<details>

<summary>Authorization</summary>

API Key

</details>

### Query parameters

* page (integer, optional)&#x20;
* page\_size (integer, optional)
* order (string optional)

## Response

* &#x20;200 Successful Response
  * total\_pages (Integer): The total number of pages available for querying
  * knowledge\_bases : An array of knowledges bases being queried

```json
{
  "total_pages": 0,
  "knowledge_bases": [
    {
      "knowledge_base_id": "b2cb7d2c-5922-4dad-94b5-65b657e02a9c",
      "name": "Johns knowledgebase",
      "document_details": [
        {
          "doc_id": "b2cb7d2c-5922-4dad-94b5-65b657e02a9c",
          "name": "new_docs.pdf"
        }
      ],
      "date_time": "2024-08-21T12:38:07.085Z"
    }
  ]
}
```

* 422 : Validation Error&#x20;

```json
{
  "detail": [
    {
      "loc": [
        "string",
        0
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}
```

## Examples

{% tabs %}
{% tab title="Curl" %}

```markup
curl -H "x-api-key: YOUR_API_KEY"
     -X GET "https://api.askyourpdf.com/v1/api/knowledge"

```

{% endtab %}

{% tab title="Python" %}

```python

import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

response = requests.get('https://api.askyourpdf.com/v1/api/knowledge', headers=headers)

if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)
```

{% endtab %}

{% tab title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
    'x-api-key': 'YOUR_API_KEY'
};

axios.get('https://api.askyourpdf.com/v1/api/knowledge', { headers })
    .then(response => {
        console.log(response.data);
    })
    .catch(error => {
        console.error('Error:', error.response ? error.response.status : error.message);
    });

```

{% endtab %}
{% endtabs %}

### 9. Create Knowledge Base

This endpoint enables a user to create a knowlege base from the list of document IDs

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/api/knowledge" method="post" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

\
Returns: \
KnowledgeBaseResponse: The response containing the knowledge base ID.

### Body

* name \* (string, required) : The name of the knowledgebase
* document\_ids \* (array, required)  : The documents Ids to be included in the knowledgebase

```json
{
  "name": "Johns knowledgebase",
  "document_ids": [
    "b2cb7d2c-5922-4dad-94b5-65b657e02a9c"
  ]
}
```

```
POST /api/knowledge
```

<details>

<summary>Authorization</summary>

API Key

</details>

## Response

* 201 : Successful Response
  * KnowlegeBaseResponse : A dictionary of knowledge\_base\_id created

```json
{
  "knowledge_base_id": "b2cb7d2c-5922-4dad-94b5-65b657e02a9c"
}
```

* 422: Validation Error

```json
{
  "detail": [
    {
      "loc": [
        "string",
        0
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}
```

## Examples

{% tabs %}
{% tab title="Curl" %}
curl -X POST '<https://api.askyourpdf.com/v1/api/knowledge'\\>
-H 'x-api-key: YOUR\_API\_KEY'\
-H 'Content-Type: application/json'\
-d '{ "name": "string", "document\_ids": \[ "string" ] }'
{% endtab %}

{% tab title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

payload = {
  "name": "string",
  "document_ids": [
    "string"
  ]
}
response = requests.post('https://api.askyourpdf.com/v1/api/knowledge', json=payload, headers=headers)

if response.status_code == 201:
    print(response.json())
else:
    print('Error:', response.status_code)
```

{% endtab %}

{% tab title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
  'x-api-key': 'YOUR_API_KEY'
};

const payload = {
  "name": "string",
  "document_ids": [
    "string"
  ]
};

axios.post('https://api.askyourpdf.com/v1/api/knowledge', payload, { headers })
  .then(response => {
    if (response.status === 201) {
      console.log(response.data);
    } else {
      console.log('Error:', response.status);
    }
  })
  .catch(error => {
    console.error('Error:', error.response ? error.response.status : error.message);
  });
```

{% endtab %}
{% endtabs %}

## 10.  Get KnowledgeBase

This endpoint enables a user to retrieve a single knowledge base

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/api/knowledge/{knowledge\_base\_id}" method="get" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

Args: \
knowledge\_base\_id: The ID of the knowledge base to retrieve

Returns: KnowledgeDetailedResponse: The response containing the updated knowledge base.

### Path parameter

knowledge\_base\_id \* (string, required)

```
GET /api/knowledge/{knowledge_base_id}
```

<details>

<summary>Authorization</summary>

API Key

</details>

## Response

* 200 : Succesful Response

```json
{
  "knowledge_base_id": "b2cb7d2c-5922-4dad-94b5-65b657e02a9c",
  "name": "askyourpdf",
  "document_details": [
    {
      "doc_id": "b2cb7d2c-5922-4dad-94b5-65b657e02a9c",
      "name": "docs_name.pdf"
    }
  ],
  "date_time": "2024-08-22T15:41:56.723Z"
}
```

* 422  : Validator Error

```json
{
  "detail": [
    {
      "loc": [
        "string",
        0
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}
```

## Examples

{% tabs %}
{% tab title="Curl" %}
curl -X GET '<https://api.askyourpdf.com/v1/api/knowledge/YOUR\\_KNOWLEDGE\\_BASE\\_ID'\\>
-H 'x-api-key: YOUR\_API\_KEY'
{% endtab %}

{% tab title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

response = requests.get('https://api.askyourpdf.com/v1/api/knowledge/{knowledge_base_id}', headers=headers)

if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)
```

{% endtab %}

{% tab title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
  'x-api-key': 'YOUR_API_KEY'
};

const knowledgeBaseId = 'YOUR_KNOWLEDGE_BASE_ID';

axios.get(`https://api.askyourpdf.com/v1/api/knowledge/${knowledgeBaseId}`, { headers })
  .then(response => {
    if (response.status === 200) {
      console.log(response.data);
    } else {
      console.log('Error:', response.status);
    }
  })
  .catch(error => {
    console.error('Error:', error.response ? error.response.status : error.message);
  });
```

{% endtab %}
{% endtabs %}

## 11. Update Knowledge Base

This endpoint enables a user to update a knowledge base

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/api/knowledge/{knowledge\_base\_id}" method="put" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

Args: \
knowledge\_base\_id: The ID of the knowledge base to update.

Returns: \
KnowledgeDetailedResponse: The response containing the updated knowledge base.

### Path parameter

knowledge\_base\_id\* (string, required)

### Body

* name (string) : A new name for your knowledge base
* document\_ids: (string) An array of documents IDs you wish to update your knowledgebase with

```json
{
"name": "new knowledgbebase name",
  "document_ids": [
    "b2cb7d2c-5922-4dad-94b5-65b657e02a9c"
  ]
}
```

```
PUT /api/knowledge/{knowledge_base_id}
```

<details>

<summary>Authorization</summary>

API Key

</details>

## Response

* 200 : Successful Response

```json
{
  "knowledge_base_id": "d2cb3e2c-5922-4dad-94b5-65b657e12a9c",
  "name": "KB1",
  "document_details": [
    {
      "doc_id": "b2cb7d2c-5922-4dad-94b5-65b657e02a9c",
      "name": "wolf_of_wallstreet.pdf"
    }
  ],
  "date_time": "2024-08-22T17:50:12.964Z"
}
```

* 422 : Validator Error

```json
{
  "detail": [
    {
      "loc": [
        "string",
        0
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}
```

## Examples

{% tabs %}
{% tab title="Curl" %}

```markup
curl -X PUT 'https://api.askyourpdf.com/v1/api/knowledge/YOUR_KNOWLEDGE_BASE_ID' \
-H 'x-api-key: YOUR_API_KEY' \
-H 'Content-Type: application/json' \
-d '{
  "name": "string",
  "document_ids": [
    "string"
  ]
}'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

headers = {
    'x-api-key': 'YOUR_API_KEY'
}

payload  = {
  "name": "string",
  "document_ids": [
    "string"
  ]
}

response = requests.put('https://api.askyourpdf.com/v1/api/knowledge/{knowledge_base_id}', json = payload, headers=headers)

if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)
```

{% endtab %}

{% tab title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
  'x-api-key': 'YOUR_API_KEY'
};

const payload = {
  "name": "string",
  "document_ids": [
    "string"
  ]
};

const knowledgeBaseId = 'YOUR_KNOWLEDGE_BASE_ID';

axios.put(`https://api.askyourpdf.com/v1/api/knowledge/${knowledgeBaseId}`, payload, { headers })
  .then(response => {
    if (response.status === 200) {
      console.log(response.data);
    } else {
      console.log('Error:', response.status);
    }
  })
  .catch(error => {
    console.error('Error:', error.response ? error.response.status : error.message);
  });
```

{% endtab %}
{% endtabs %}

## 12. Delete Knowledge Base

This endpoint enables a user to delete a knowledge base

{% openapi src="<https://api.askingstage.com/openapi.json>" path="/api/knowledge/{knowledge\_base\_id}" method="delete" %}
<https://api.askingstage.com/openapi.json>
{% endopenapi %}

Args: \
knowledge\_base\_id: The ID of the knowledge base to delete

Returns: dict: The response containing a success message

### Path parameter

knowledge\_base\_id\* (string, required)

```
DELETE /api/knowledge/{knowledge_base_id}
```

<details>

<summary>Authorization</summary>

API Key

</details>

## Response

* 200 : Successful Response

```json
{"message": "Knowledge base deleted successfully"}

```

## Examples

{% tabs %}
{% tab title="Curl" %}
curl -X DELETE '<https://api.askyourpdf.com/v1/api/knowledge/YOUR\\_KNOWLEDGE\\_BASE\\_ID'\\>
-H 'x-api-key: YOUR\_API\_KEY'
{% endtab %}

{% tab title="Python" %}

```python
import requests

headers = {
'x-api-key': 'YOUR_API_KEY'
}

response = requests.delete('https://api.askyourpdf.com/v1/api/knowledge/{knowledge_base_id}', headers=headers)
if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)
```

{% endtab %}

{% tab title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
  'x-api-key': 'YOUR_API_KEY'
};

const knowledgeBaseId = 'YOUR_KNOWLEDGE_BASE_ID';

axios.delete(`https://api.askyourpdf.com/v1/api/knowledge/${knowledgeBaseId}`, { headers })
  .then(response => {
    if (response.status === 200) {
      console.log(response.data);
    } else {
      console.log('Error:', response.status);
    }
  })
  .catch(error => {
    console.error('Error:', error.response ? error.response.status : error.message);
  });
```

{% endtab %}
{% endtabs %}

## 13.  Search Knowledge Base

This endpoint  retrieves a list of  knowledgebases based on a user's query

Args: \
query: The search query is used to filter knowledgebases by name

Returns: \
KnowledgeBase: A list of knowledges matching the query

### Query parameter

* query\* (string, required)

```
GET /api/search/knowledge
```

<details>

<summary>Authorization</summary>

API Key

</details>

## Response

* 200 : Successful Response

```json
[
  {
    "knowledge_base_id": "string",
    "name": "string",
    "document_details": [
      {
        "doc_id": "string",
        "name": "string"
      }
    ],
    "date_time": "2024-08-22T19:27:28.485Z"
  }
]
```

* 422 : Validator Error

```json
{
  "detail": [
    {
      "loc": [
        "string",
        0
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}
```

## Examples

{% tabs %}
{% tab title="Curl" %}
curl -X GET '<https://api.askyourpdf.com/v1/api/search/knowledge?query=YOUR\\_QUERY'\\>
-H 'x-api-key: YOUR\_API\_KEY'
{% endtab %}

{% tab title="Python" %}

```python
import requests

headers = {
'x-api-key': 'YOUR_API_KEY'
}

response = requests.get('https://api.askyourpdf.com/v1/api/search/knowledge?query={QUERY}', headers=headers)
if response.status_code == 200:
    print(response.json())
else:
    print('Error:', response.status_code)
```

{% endtab %}

{% tab title="Javascript" %}

```javascript
const axios = require('axios');

const headers = {
  'x-api-key': 'YOUR_API_KEY'
};

const query = 'YOUR_QUERY';

axios.get(`https://api.askyourpdf.com/v1/api/search/knowledge?query=${query}`, { headers })
  .then(response => {
    if (response.status === 200) {
      console.log(response.data);
    } else {
      console.log('Error:', response.status);
    }
  })
  .catch(error => {
    console.error('Error:', error.response ? error.response.status : error.message);
  });
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.askyourpdf.com/api/askyourpdf-api-documentation.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
